defmodule Dinge.Application do
  # See https://hexdocs.pm/elixir/Application.html
  # for more information on OTP Applications
  @moduledoc false

  use Application

  @impl true
  def start(_type, _args) do
    children = [
      DingeWeb.Telemetry,
      Dinge.Repo,
      {DNSCluster, query: Application.get_env(:dinge, :dns_cluster_query) || :ignore},
      {Phoenix.PubSub, name: Dinge.PubSub},
      # Start the Finch HTTP client for sending emails
      {Finch, name: Dinge.Finch},
      # Start a worker by calling: Dinge.Worker.start_link(arg)
      # {Dinge.Worker, arg},
      # Start to serve requests, typically the last entry
      DingeWeb.Endpoint
    ]

    # See https://hexdocs.pm/elixir/Supervisor.html
    # for other strategies and supported options
    opts = [strategy: :one_for_one, name: Dinge.Supervisor]
    Supervisor.start_link(children, opts)
  end

  # Tell Phoenix to update the endpoint configuration
  # whenever the application is updated.
  @impl true
  def config_change(changed, _new, removed) do
    DingeWeb.Endpoint.config_change(changed, removed)
    :ok
  end
end
