defmodule Dinge.Ledger.Ding do
  use Ecto.Schema
  import Ecto.Changeset

  schema "dings" do
    field :count, :integer
    field :status, Ecto.Enum, values: [:active, :inactive, :finished, :hidden, :deleted]
    field :title, :string
    field :target_count, :integer
    field :ding_type, Ecto.Enum, values: [:countdown, :countup]
    field :target_type, Ecto.Enum, values: [:default, :daily, :weekly, :monthly]
    belongs_to :user, Dinge.Accounts.User

    timestamps(type: :utc_datetime)
  end

  @doc false
  def changeset(ding, attrs) do
    ding
    |> cast(attrs, [:title, :count, :target_count, :ding_type, :target_type, :status, :user_id])
    |> cast_assoc(:user)
    |> validate_required([:title, :count, :target_count, :ding_type, :target_type, :status, :user_id])
  end
end
