defmodule DingeWeb.DingLive.Show do
  use DingeWeb, :live_view

  alias Dinge.Ledger

  @impl true
  def mount(_params, _session, socket) do
    {:ok, socket}
  end

  @impl true
  def handle_params(%{"id" => id}, _, socket) do
    {:noreply,
     socket
     |> assign(:page_title, page_title(socket.assigns.live_action))
     |> assign(:ding, Ledger.get_ding!(id))}
  end

  defp page_title(:show), do: "Show Ding"
  defp page_title(:edit), do: "Edit Ding"
end
